{$U-,C-,R-}
program wxterm;
{
Scott Murphy
77 So. Adams St. #301
Denver, CO 80209
Compuserve 70156,263
}
Const
     VERSION = '3.0';
     BELL_FREQ = 440;                  {frequncy for bell sound}
     BELL_DELAY = 100;                 {duration of bell sound}
     DEFAULT_BAUD = 1200;               {Serial port speed at start-up}

type
    bigstring        = string[80];    {general purpose}
    cset              = set of 0..127;
var
   pcjrmode              : boolean;
   exit,
   xtnd  : boolean;
   a     : byte;
   c,i   : integer;
   ch : char;

{$C-,R-,U-,K-}
{$I WXTMPORT.INC}
{$I WXTMMISC.INC}

procedure processcom;
var
   c    :   integer;
begin
     c := cgetc(0);
     case c of
         -1 : begin
              end; {no action}
          9 : {tab}
              begin
                   for c := WhereX to (WhereX div 8 + 1)*8 do
                       write(' ');
                   c := 9
              end;
          7 : {bell}
               begin
                    sound(BELL_FREQ);
                    delay(BELL_DELAY);
                    NoSound
               end;
          12 : {form-feed}
               ClrScr;
         else  write(chr(c and $7F));
     end;
end;
{$I WXTMWIND.INC}
{$I WXTMXFER.INC}
{$I WXTMDIAL.INC}


begin
     ScreenBase := $B000;                       {assume monochrome}
     MemW[ ScreenBase:0000 ]   := 69;
     if Mem[ ScreenBase:0000 ] <> 69 then
        ScreenBase := $B800;
     ClrScr;
     InitWindow(StatWin,1,1,80,2);
     InitWindow(TermWin,1,3,80,25);
     CurrentWin := TermWin;
     UsePermWindow(TermWin);
     status(1,'WXTERM ver: ' + VERSION);
     status(2,'Initializing');
     setup;
     init_port;
     term_ready(true);
     set_up_recv_buffer;
     remove_port;
     init_port;
     term_ready(true);
     set_up_recv_buffer;
     exit := false;
     GotoXY(1,1);
     if carrier then
        status(2,'On-Line/Ready')
     else
        status(2,'Off-Line/Ready');
     status(3,'[Home] for help');
     writeln('Press [Home] for help');
     while not exit do
     begin
          if scan(xtnd,a) then
          begin
               if xtnd then
               begin
                  case a of
                       19   : {alt-R}
                              recv_wcp;
                       45   : {alt-X}
                              begin
                                   OpenTemp(20,18,60,22,1);
                                   writeln('WXTERM');
                                   write('Do you really want to exit (Y/N)? ');
                                   readln(ch);
                                   if upcase(ch) = 'Y' then
                                      exit := TRUE;
                                   CloseTemp
                              end;
                       31   : {alt-S}
                              send_wcp;
                       35   : {alt-H}
                              begin
                                   writeln('WXTERM');
                                   status(2,'Disconnecting');
                                   term_ready(FALSE);
                                   delay(500);
                                   term_ready(TRUE);
                                   status(2,'Off-Line/Ready')
                              end;
                       46   : {alt-C}
                              ClrScr;
                       48   : {alt-B}
                              break;
                       25   : {alt-P}
                              NewParms;
                       72   : {Cursor up}
                              PushPage;
                       80   : {Cursor Down}
                              PopPage;
                       71   : {Home}
                              begin
                                OpenTemp(40,3,80,10,2);
                                writeln('Alt-X exit         Alt-H hang up');
                                writeln('Alt-R Xmodem recv  Alt-S Xmodem send');
                                writeln('Alt-B send break   Alt-C clear screen');
                                writeln('        Alt-P comm params  ');
                                writeln('      Press any key to continue');
                                repeat
                                until (keypressed);
                                Clrscr;
                                CloseTemp;
                             end;
                  end; {case}
               end     {if extended key}
               else    {not extended}
                  send(a);
          end; {if KeyPressed}
          processcom;
     end; {while not exit}
     remove_port;
end.
